/* 
   Hilfsprogramm zum Ausgeben der auf Platte gespeicherten Hamiltonmatrix
   evl. muss die Struktur an das jeweilige Programm angepasst werden
*/

#include <stdio.h>
#include <stdlib.h>

#define IFILE "hxy.tmp"

struct thxy { unsigned long y;
              double h;}; 	/* y,h[x,y] if(x=y)x++; 	*/

#define BUFLEN 100000
double 		hbuf[BUFLEN];		/* Puffer fuer Matrixzeile */
unsigned long 	ybuf[BUFLEN];		/* Puffer fuer Matrixzeile */
int    		next[BUFLEN];		/* sortierindex */
int    		hanz[BUFLEN];		/* zaehler vielfachheit */
int    		hlen=0,start=0;

int vvv=0;

int main(){
  FILE *f1; struct thxy h1; unsigned long x=0l,a1=0l,a2=0l; int i,j,jj;
  f1=fopen(IFILE,"rb");
  if(!f1){fprintf(stderr,"Fehler beim oeffnen der Datei "IFILE);return 1; }
  while(!feof(f1)){
    if(fread(&h1,sizeof(struct thxy),1,f1)!=1)break;a1++;
    if(vvv&1)printf("\nx=%12lu y=%12lu h=%20e",x,h1.y,h1.h);
    /* suche h in tab und sortiere ein */
    for(jj=j=start,i=0;i<hlen;i++,j=next[j])if(h1.y<=ybuf[j])break;else jj=j;
    if(i==hlen){	/* nicht gefunden */
      hbuf[hlen]=h1.h;ybuf[hlen]=h1.y;
      next[jj]=hlen;next[hlen]=hlen;hanz[hlen]=1;hlen++;
      if(hlen>=BUFLEN){ fprintf(stderr,"OVL");return(2); } 
    } 
    else  if(ybuf[j]!=h1.y){	/* nicht gefunden */
      hbuf[hlen]=h1.h;ybuf[hlen]=h1.y;
      if(j==start)start=hlen;else next[jj]=hlen;/* vorn oder mittig? */
      next[hlen]=j;hanz[hlen]=1;hlen++; 
    } 
    else {
      hbuf[j]+=h1.h; hanz[j]++; a2++; }
    if(x==h1.y){
      if(vvv&2)for(j=start,i=0;i<hlen;i++,j=next[j])
        printf("\nx=%12lu y=%12lu h=%20e r=%5d",x,ybuf[j],hbuf[j],hanz[j]);
      if(x&(1024*1024))printf("\n input=%12lu output=%12lu  ratio=%lu",a1,a2,a1/a2);
      x++; hlen=start=0; }	/* naechste Zeile */
  }
  fclose(f1); 
  printf("\n input=%12lu output=%12lu  ratio=%lu",a1,a2,a1/a2);
  return 0; }
